"use strict"

{
	const C3 = globalThis.C3

	C3.Behaviors.overboy_array_b.Cnds = {
		CompareX(x, cmp, val) {
			return C3.compare(this.At(x, 0, 0), cmp, val)
		},
		CompareXY(x, y, cmp, val) {
			return C3.compare(this.At(x, y, 0), cmp, val)
		},
		CompareXYZ(x, y, z, cmp, val) {
			return C3.compare(this.At(x, y, z), cmp, val)
		},
		ArrForEach(dims) {
			const runtime = this._runtime
			const forDepth = ++this._forDepth
			const forX = this._forX
			const forY = this._forY
			const forZ = this._forZ
			const cx = this._cx
			const cy = this._cy
			const cz = this._cz
			if (forDepth === this._forX.length) {
				forX.push(0)
				forY.push(0)
				forZ.push(0)
			} else {
				forX[forDepth] = 0
				forY[forDepth] = 0
				forZ[forDepth] = 0
			}
			//runtime.SetDebuggingEnabled(false)
			const loopCtx = this.runtime.sdk.createLoopingConditionContext();
			if (dims === 0)
				for (let x = 0; x < cx; ++x)
					for (let y = 0; y < cy; ++y)
						for (let z = 0; z < cz; ++z) {
							forX[forDepth] = x
							forY[forDepth] = y
							forZ[forDepth] = z

							loopCtx.retrigger();

							if (loopCtx.isStopped)
								break;
						}
			else if (dims === 1)
				for (let x = 0; x < cx; ++x)
					for (let y = 0; y < cy; ++y) {
						forX[forDepth] = x
						forY[forDepth] = y

						loopCtx.retrigger();

						if (loopCtx.isStopped)
							break;
					}
			else
				for (let x = 0; x < cx; ++x) {
					forX[forDepth] = x

					loopCtx.retrigger();

					if (loopCtx.isStopped)
						break;
				}
			//runtime.SetDebuggingEnabled(true)
			this._forDepth--
			loopCtx.release();
			return false
		},
		CompareCurrent(cmp, val) {
			return C3.compare(this.At(this._GetForX(), this._GetForY(), this._GetForZ()), cmp, val)
		},
		Contains(val) {
			const cx = this._cx
			const cy = this._cy
			const cz = this._cz
			const arr = this._arr
			for (let x = 0; x < cx; ++x) for (let y = 0; y < cy; ++y) for (let z = 0; z < cz; ++z) if (arr[x][y][z] === val) return true
			return false
		},
		IsEmpty() {
			return this._cx === 0 || this._cy === 0 || this._cz === 0
		},
		CompareSize(axis, cmp, val) {
			let s = 0
			switch (axis) {
				case 0:
					s = this._cx
					break
				case 1:
					s = this._cy
					break
				case 2:
					s = this._cz
					break
			}
			return C3.compare(s, cmp, val)
		}
	}
}
